#ifndef ARIB_UTIL_H
#define ARIB_UTIL_H

#include <string.h>
#include <stdio.h>

static void extract_mjd(int *yy, int *mm, int *dd, int mjd)
{
	int a1,m1;
	int a2,m2;
	int a3,m3;
	int a4,m4;
	int mw;
	int dw;
	int yw;
	
	mjd -= 51604; // 2000,3/1
	if(mjd < 0){
		mjd += 0x10000;
	}

	a1 = mjd / 146097;
	m1 = mjd % 146097;
	a2 = m1 / 36524;
	m2 = m1 - (a2 * 36524);
	a3 = m2 / 1461;
	m3 = m2 - (a3 * 1461);
	a4 = m3 / 365;
	if(a4 > 3){
		a4 = 3;
	}
	m4 = m3 - (a4 * 365);
	
	mw = (1071*m4+450) >> 15;
	dw = m4 - ((979*mw+16) >> 5);

	yw = a1*400 + a2*100 + a3*4 + a4 + 2000;
	mw += 3;
	if(mw > 12){
		mw -= 12;
		yw += 1;
	}
	dw += 1;

	*yy = yw;
	*mm = mw;
	*dd = dw;
}

static void extract_transport_stream_id(char *dst, int transport_id)
{
	int network,channel,slot;
	
	network = (transport_id >> 12) & 0x0f;
	channel = (transport_id >>  4) & 0x1f;
	slot    = (transport_id      ) & 0x07;

	switch(network) {
	case 4:
		sprintf(dst, "BS-%02d/TS-%1d", channel, slot);
		break;
	case 6:
	case 7:
		sprintf(dst, "ND-%02d/TS-%1d", channel, slot);
		break;
	default:
		sprintf(dst, "UNK(%5d)", transport_id);
		break;
	}
}

#endif /* ARIB_UTIL_H */