/* cascmd.exe */
/* Special thanks to http://eternalwindows.jp/security/scard/scard00.html */

#include <windows.h>
#include <winscard.h>
#include <stdio.h>
#include <stdlib.h>

#pragma comment (lib, "winscard.lib")


BYTE c_to_hex( const char c )
{
	if( '0' <= c && c <= '9' ) {
		return (BYTE)(c-'0');
	} else if( 'A' <= c && c <= 'F' ) {
		return (BYTE)(c-'A') + 0x0A;
	} else if( 'a' <= c && c <= 'f' ) {
		return (BYTE)(c-'a') + 0x0A;
	} else {
		return 0;
	}
}

int is_validchar( char c )
{
	if( '0' <= c && c <= '9' ) {
		return 1;
	} else if( 'A' <= c && c <= 'F' ) {
		return 1;
	} else if( 'a' <= c && c <= 'f' ) {
		return 1;
	} else {
		return 0;
	}
}

hex_to_c2( BYTE b, char *str )
{
	const char t[] = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F' };
	str[0] = t[b/16];
	str[1] = t[b%16];
}

BOOL send_command( SCARDHANDLE hCard, BYTE *command, DWORD cmd_length, BYTE *response, DWORD *res_length )
{
	if( SCardTransmit(hCard, SCARD_PCI_T1, command, cmd_length, NULL, response, res_length) == SCARD_S_SUCCESS ) {
		return TRUE;
	}
	return FALSE;
}

BOOL send_command_str( SCARDHANDLE hCard,  const char *cmd_str, char *res_str, size_t maxlen )
{
	int n, i;
	const char *p;
	BYTE *cmdbuf, *resbuf;
	DWORD cmdlen, reslen;

	for( n=0, p=cmd_str; *p != '\0'; p++ ) {
		if( is_validchar(*p) ) { n++; } 
	}

	cmdlen = n/2;
	reslen = 524288;
	cmdbuf = (BYTE*)malloc(cmdlen);
	resbuf = (BYTE*)malloc(reslen);

	for( i=0, p=cmd_str; i < (int)cmdlen; i++ ) {
		while( ! is_validchar(*p) ) { p++; }
		cmdbuf[i] = c_to_hex(*p) << 4;
		p++;
		while( ! is_validchar(*p) ) { p++; }
		cmdbuf[i] += c_to_hex(*p);
		p++;
	}

	if( ! send_command( hCard, cmdbuf, cmdlen, resbuf, &reslen ) ) {
		res_str[0] = '\0';
		return FALSE;
	}

	for( i=0; i<(int)reslen && i*3 < (int)maxlen-1; i++ ) {
		hex_to_c2( resbuf[i], &res_str[i*3] );
		res_str[i*3+2] = ' ';
	}
	res_str[i*3] = '\0';

	free(cmdbuf);
	free(resbuf);

	return TRUE;
}

void loadfile( const char *fname, char *str, size_t max_read_byte )
{
	FILE *fp;
	size_t rb;

	fp = fopen( fname, "r" );
	if( fp == NULL ) {
		fprintf(stderr, "fopen error: %s\n", fname );
		str[0] = '\0';
		return;
	}
	rb = fread( str, 1, max_read_byte, fp );
	fclose(fp);
	str[rb] = '\0';

	return;
}

int main(int argc, char *argv[])
{
	SCARDCONTEXT hContext;
	SCARDHANDLE  hCard;
	LPTSTR       lpszReaderName;
	LONG         lResult;
	DWORD        dwActiveProtocol;
	DWORD        dwAutoAllocate = SCARD_AUTOALLOCATE;

	char *cmdstr;
	char *str;
	int i;

	lResult = SCardEstablishContext(SCARD_SCOPE_USER, NULL, NULL, &hContext);
	if (lResult != SCARD_S_SUCCESS) {
		if (lResult == SCARD_E_NO_SERVICE)
			MessageBox(NULL, TEXT("Smart CardT[rXNĂ܂B"), NULL, MB_ICONWARNING);
		return 0;
	}

	lResult = SCardListReaders(hContext, NULL, (LPTSTR)&lpszReaderName, &dwAutoAllocate);
	if (lResult != SCARD_S_SUCCESS) {
		if (lResult == SCARD_E_NO_READERS_AVAILABLE)
			MessageBox(NULL, TEXT("J[h[_ڑĂ܂B"), NULL, MB_ICONWARNING);
		SCardReleaseContext(hContext);
		return 0;
	}

	lResult = SCardConnect(hContext, lpszReaderName, SCARD_SHARE_SHARED, SCARD_PROTOCOL_T0 | SCARD_PROTOCOL_T1, &hCard, &dwActiveProtocol);
	if (lResult != SCARD_S_SUCCESS) {
		if (lResult == SCARD_W_REMOVED_CARD)
			MessageBox(NULL, TEXT("J[hZbgĂ܂B"), NULL, MB_ICONWARNING);
		SCardFreeMemory(hContext, lpszReaderName);
		SCardReleaseContext(hContext);
		return 0;
	}

	cmdstr = (char*)malloc(524288);
	str = (char*)malloc(524288);
	
	if( argc <= 1 ) {
		while(1) {
			gets(cmdstr);
			if( cmdstr[0] == '\0' ) {
				printf(">quit\n");
				break;
			}
			send_command_str( hCard, cmdstr, str, 524288);
			printf( ">%s\n", str );
		}
	} else {
		for( i=1; i<argc; i++ ) {
			if( strcmp( argv[i], "-f" ) == 0 ) {
				loadfile( argv[i+1], cmdstr, 524288 );
				send_command_str( hCard, cmdstr, str, 524288);
				i++;
				printf("%s\n", cmdstr);
			} else {
				send_command_str( hCard, argv[i], str, 524288);
				printf("%s\n", argv[i]);
			}

			printf( ">%s\n", str );
		}
	}

	SCardDisconnect(hCard, SCARD_LEAVE_CARD);

	SCardFreeMemory(hContext, lpszReaderName);
	SCardReleaseContext(hContext);

	free(cmdstr);
	free(str);

	return 0;
}
